#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <shlobj.h>
#include <shlguid.h>
#include "resource.h"

IEnumString *s_pEnum = NULL;
IACList2 *s_pACL = NULL;
IPersistFolder *s_pPF = NULL;
ICurrentWorkingDirectory *s_pCWD = NULL;

BOOL OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    CoCreateInstance(CLSID_ACListISF, NULL, CLSCTX_INPROC_SERVER,
        IID_IEnumString, (LPVOID *)&s_pEnum);
    s_pEnum->QueryInterface(IID_IACList2, (LPVOID *)&s_pACL);
    s_pEnum->QueryInterface(IID_IPersistFolder, (LPVOID *)&s_pPF);
    s_pEnum->QueryInterface(IID_ICurrentWorkingDirectory, (LPVOID *)&s_pCWD);
    return TRUE;
}

void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK:
    case IDCANCEL:
        s_pEnum->Release();
        s_pACL->Release();
        s_pPF->Release();
        s_pCWD->Release();
        EndDialog(hwnd, id);
        break;
    case psh1: // Initialize
        {
            WCHAR szPath[MAX_PATH];
            GetDlgItemTextW(hwnd, edt1, szPath, MAX_PATH);
            LPITEMIDLIST pidl = ILCreateFromPathW(szPath);
            s_pPF->Initialize(pidl);
            ILFree(pidl);
        }
        break;
    case psh2: // Expand
        {
            WCHAR szPath[MAX_PATH];
            GetDlgItemTextW(hwnd, edt2, szPath, MAX_PATH);
            s_pACL->Expand(szPath);
        }
        break;
    case psh3: // SetDirectory
        {
            WCHAR szPath[MAX_PATH];
            GetDlgItemTextW(hwnd, edt3, szPath, MAX_PATH);
            s_pCWD->SetDirectory(szPath);
        }
        break;
    case psh4: // Reset
        {
            s_pEnum->Reset();
        }
        break;
    case psh5: // get list
        {
            LPOLESTR rgelt;
            ULONG cGot;
            HRESULT hr;

            ListBox_ResetContent(GetDlgItem(hwnd, lst1));

            for (;;)
            {
                hr = s_pEnum->Next(1, &rgelt, &cGot);
                if (hr != S_OK)
                    break;
                ListBox_AddString(GetDlgItem(hwnd, lst1), rgelt);
                CoTaskMemFree(rgelt);
            }
        }
        break;
    case psh6: // clear list
        ListBox_ResetContent(GetDlgItem(hwnd, lst1));
        break;
    }
}

INT_PTR CALLBACK
DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_INITDIALOG, OnInitDialog);
        HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
    }
    return 0;
}

INT WINAPI
WinMain(HINSTANCE   hInstance,
        HINSTANCE   hPrevInstance,
        LPSTR       lpCmdLine,
        INT         nCmdShow)
{
    CoInitialize(NULL);
    InitCommonControls();
    DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, DialogProc);
    CoUninitialize();
    return 0;
}
